#include <bits/stdc++.h>
#include <windows.h>
using namespace std;

const int MAXN=1050;

int n, m;
int g[MAXN][MAXN];
int len[MAXN][MAXN]; // len[x][y] <- (1, 1) to (x, y) step
int visited[MAXN][MAXN];
string path[MAXN][MAXN]; 
string dir[4] = {"", "", "", ""};

int kx[4] = {0, 0, 1, -1};
int ky[4] = {1, -1, 0, 0};
void Dfs(int xpos, int ypos, int step) { // calculate len[][]
	for(int i = 1; i <= n; i++) {
		for(int j = 1; j <= m; j++) {
			cout << path[i][j];
		}
		cout << endl;
	}
	system("pause"); 
	
	len[xpos][ypos] = min(len[xpos][ypos], step);
	for(int k = 0; k <= 3; k++) {
		int newx = xpos + kx[k];
		int newy = ypos + ky[k];
		if(newx == 0 or newy == 0 or newx == n + 1 or newy == m + 1) {
			continue;
		}
		if(g[newx][newy] == 1) {
			continue;
		}
		if(visited[newx][newy] == true) {
			continue;
		}
		visited[newx][newy] = true;
		path[xpos][ypos] = dir[k];
		path[newx][newy] = "";
		Dfs(newx, newy, step + 1);
		path[newx][newy] = "  ";
		visited[newx][newy] = false;
		for(int i = 1; i <= n; i++) {
			for(int j = 1; j <= m; j++) {
				cout << path[i][j];
			}
			cout << endl;
		}
		system("pause"); 
	}
}

int main() {
	cin >> n >> m;
	for(int i = 1; i <= n; i++) {
		for(int j = 1; j <= m; j++) {
			cin >> g[i][j];
			len[i][j] = 1000000007;
			path[i][j] = "  ";
		}
	}
	visited[1][1] = true;
	Dfs(1, 1, 0);
	visited[1][1] = false;
	cout << len[n][m] << endl;
	return 0;
}
